/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "tileset.h"

tileset_t TILESETS[TILESET_COUNT] = {
  // TILESET_NULL
  { 0, 0 },
  // TILESET_FONT
  { 16, 14 }
};

tilesetid_t TILESET_SLOTS[TILESET_SLOT_COUNT] = {
  TILESET_NULL,
  TILESET_NULL,
  TILESET_NULL,
  TILESET_NULL
};

uint8_t tilesetGetSlot(const tilesetid_t id) {
  uint8_t i = 0;
  do {
    if(TILESET_SLOTS[i] == id) return i;
  } while(++i < TILESET_SLOT_COUNT);
  return 0xFF;
}

bool_t tilesetIsBound(const tilesetid_t id) {
  return tilesetGetSlot(id) != 0xFF;
}