/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

#define GAME_TICK_RATE 60

typedef struct {
  uint32_t tick;
} game_t;

extern game_t GAME;

/**
 * Initializes the game.
 */
void gameInit();

/**
 * Updates the game. The game is setup to handle "frames", aka 1/60th of a 
 * second. Typically more modern engines would use floats to tick game engine
 * by a semi random delta time, but this engine is intended to work on really
 * weak machines so we take the simple approach.
 */
void gameUpdate();

/**
 * Disposes the game.
 */
void gameDispose();