/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "input.h"

inputstate_t INPUT_CURRENT;
inputstate_t INPUT_LAST_FRAME;

void inputInit() {
  INPUT_CURRENT = 0;
  INPUT_LAST_FRAME = 0;
}

void inputUpdate() {
  INPUT_LAST_FRAME = INPUT_CURRENT;
  INPUT_CURRENT = inputPlatformState();
}

bool_t inputWasPressed(const inputstate_t state) {
  return (INPUT_LAST_FRAME & state) == 0 && (INPUT_CURRENT & state) != 0;
}

bool_t inputWasReleased(const inputstate_t state) {
  return (INPUT_LAST_FRAME & state) != 0 && (INPUT_CURRENT & state) == 0;
}

bool_t inputIsDown(const inputstate_t state) {
  return (INPUT_CURRENT & state) != 0;
}

bool_t inputIsUp(const inputstate_t state) {
  return (INPUT_CURRENT & state) == 0;
}