/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct _entity_t entity_t;

typedef struct {
  int32_t nothing;
} npc_t;

/**
 * Handles initialization of an NPC.
 * 
 * @param ent The entity to initialize as an NPC.
 */
void npcInit(entity_t *ent);

/**
 * Handles updating an NPC.
 * 
 * @param ent The entity to update as an NPC.
 */
void npcUpdate(entity_t *ent);

/**
 * Handles interaction with an NPC.
 * 
 * @param player The player entity interacting.
 * @param ent The entity to interact with.
 */
void npcInteract(entity_t *player, entity_t *ent);