/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct _entity_t entity_t;

typedef struct {
  int32_t nothing;
} player_t;

/**
 * Handles initialization of the player.
 * 
 * @param ent The entity to initialize as a player.
 */
void playerInit(entity_t *ent);

/**
 * Handles updating the player.
 * 
 * @param ent The entity to update as a player.
 */
void playerUpdate(entity_t *ent);