/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef uint8_t tileid_t;

typedef struct {
  uint32_t nothing;
} tiledata_t;

#define TILE_ID_NULL 0
#define TILE_ID_GRASS 1

/**
 * Returns whether or not the tile is solid.
 * 
 * @param id The tile id to check.
 * @return Whether or not the tile is solid.
 */
bool_t tileIsSolid(const tileid_t id);