/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "duskgl.h"

typedef struct {
  GLuint quadVBO;
  GLuint quadUVVBO;
  GLuint quadVAO;
  GLuint quadEBO;
} duskquad_t;

extern duskquad_t QUAD;

/**
 * Initializes the quad.
 */
void quadInit();

/**
 * Renders quads.
 * 
 * @param count The number of quads to render.
 */
void quadRender(const int32_t count);

/**
 * Disposes of the quad.
 */
void quadDispose();