// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "../../../../dusk/display/displaydefs.h"

struct Transform {
  mat4 projection;
  mat4 view;
  vec2 resolution;
};

layout(std140) uniform b_Transforms {
  Transform transforms;
};

vec2 transformDisplayGetSize() {
  return vec2(SCREEN_WIDTH, SCREEN_HEIGHT);
}

float transformDisplayGetAspectRatio() {
  return (float(SCREEN_WIDTH) / float(SCREEN_HEIGHT));
}

vec2 transformResolutionGetSize() {
  return transforms.resolution;
}

float transformResolutionGetAspectRatio() {
  return (transforms.resolution.x / transforms.resolution.y);
}