/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/shader/shaderbuffer.h"

#define TRANSFORMS_BLOCK_NAME "b_Transforms"

typedef struct {
  mat4 projection;
  mat4 view;
  vec2 resolution;
} transformsdata_t;

extern shaderbuffer_t TRANSFORMS_BUFFER;
extern transformsdata_t TRANSFORMS_DATA;

/**
 * Initializes the transforms buffer and data.
 */
void transformsInit();

/**
 * Updates the transforms buffer with the current data.
 */
void transformsUpdate();

/**
 * Destroys the transforms buffer.
 */
void transformsDispose();