// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "../fragments/header.glsl"
#include "../data/entities.glsl"
#include "../data/tilesets.glsl"

// Inputs from vertex shader
in vec2 v_TextureCoord;

// Frag pixel color
out vec4 FragColor;

void main() {
  vec4 tColor = tilesetGetColor(uint(TILESET_SLOT_ENTITIES), v_TextureCoord);
  if(tColor.a == 0.0) discard;
  if(tColor.r == 0.0) discard;
  FragColor = vec4(1, 1, 1, 1) * tColor;
}
