// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "../fragments/header.glsl"
#include "../data/transforms.glsl"
#include "../data/entities.glsl"

// Outputs to fragment shader
out vec2 v_TextureCoord;

void main() {
  uint instanceIndex = uint(gl_InstanceID);
  uint indiceIndex = quadGetIndiceIndex(gl_VertexID);

  vec2 vert = entityGetVertice(instanceIndex, indiceIndex);
  vec2 uv = entityGetUV(instanceIndex, indiceIndex);

  gl_Position = transforms.projection * transforms.view * vec4(vert, 0.0, 1.0);
  v_TextureCoord = uv;
}