/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/shader/shader.h"

typedef struct {
  shader_t shader;

  GLuint entitiesBlock;
  GLuint transformsBlock;
  GLuint tilesetsBlock;
  
  GLuint tilesetTexturesUniform;
} entityshader_t;

extern entityshader_t ENTITY_SHADER;

/**
 * Initializes the entity shader.
 */
void entityShaderInit();

/**
 * Uses the entity shader.
 */
void entityShaderUse();

/**
 * Disposes of the entity shader.
 */
void entityShaderDispose();