// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

uint quadGetIndiceIndex(uint vertexId) {
  return vertexId % 6u;
}

uint quadGetIndiceIndex(int vertexId) {
  return quadGetIndiceIndex(uint(vertexId));
}

vec2 quadGetVertice(uint indiceIndex) {
  vec2 vert = vec2(0, 0);

  /*if(indiceIndex == 0u || indiceIndex == 4u) {
    // vert = vec2(0, 0);
  } else*/ if(indiceIndex == 1u) {
    vert = vec2(1, 0);
  } else if(indiceIndex == 2u || indiceIndex == 5u) {
    vert = vec2(1, 1);
  } else if(indiceIndex == 3u) {
    vert = vec2(0, 1);
  }
  
  return vert;
}

vec2 quadGetTextureCoordinate(uint indiceIndex) {
  vec2 vert = quadGetVertice(indiceIndex);
  return vert;
}

vec2 quadGetTextureCoordinate(uint indiceIndex, vec4 uv) {
  vec2 vert = quadGetVertice(indiceIndex);
  vert.y = 1.0 - vert.y;
  return vec2(uv.x + (uv.z - uv.x) * vert.x, uv.y + (uv.w - uv.y) * vert.y);
}