// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "../fragments/header.glsl"
#include "../data/map.glsl"

// Inputs from vertex shader
in vec2 v_TextureCoord;
flat in uint v_InstanceIndex;
flat in uint v_IndiceIndex;

// Frag pixel color
out vec4 FragColor;

void main() {
  uint layer = mapGetLayer(v_InstanceIndex);
  uint tileId = mapGetTileId(v_InstanceIndex);

  if(tileId == 0u) {
    FragColor = vec4(1, 0, 0, 1);
  } else if(tileId == 1u) {
    FragColor = vec4(0, 1, 0, 1);
  } else {
    FragColor = vec4(0, 0, 1, 1);
  }
}