// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "../fragments/header.glsl"
#include "../data/transforms.glsl"
#include "../data/map.glsl"

// Outputs to fragment shader
out vec2 v_TextureCoord;
flat out uint v_InstanceIndex;
flat out uint v_IndiceIndex;

void main() {
  uint instanceIndex = uint(gl_InstanceID);
  uint indiceIndex = quadGetIndiceIndex(gl_VertexID);

  uint layer = mapGetLayer(instanceIndex);
  vec2 vert = mapGetVertice(instanceIndex, indiceIndex);
  vec2 uv = quadGetTextureCoordinate(indiceIndex);

  gl_Position = transforms.projection * transforms.view * vec4(vert, float(layer) * 64.0, 1.0);

  v_TextureCoord = uv;
  v_InstanceIndex = instanceIndex;
  v_IndiceIndex = indiceIndex;
}