/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/shader/shader.h"

typedef struct {
  shader_t shader;
  GLuint mapBlock;
  GLuint transformsBlock;
} mapshader_t;

extern mapshader_t MAP_SHADER;

/**
 * Initializes the map shader.
 */
void mapShaderInit();

/**
 * Uses the map shader.
 */
void mapShaderUse();

/**
 * Destroys the map shader.
 */
void mapShaderDispose();