/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct {
  void (*init)();
  void (*update)();
  void (*dispose)();
} shadermanagerdatacallback_t;

typedef struct {
  void (*init)();
  void (*dispose)();
} shadermanagershadercallback_t;

extern shadermanagerdatacallback_t SHADER_MANAGER_DATA_CALLBACKS[];
extern shadermanagershadercallback_t SHADER_MANAGER_SHADER_CALLBACKS[];

#define SHADER_MANAGER_DATA_CALLBACKS_SIZE ( \
  sizeof(SHADER_MANAGER_DATA_CALLBACKS) / sizeof(shadermanagerdatacallback_t) \
)

#define SHADER_MANAGER_SHADER_CALLBACKS_SIZE ( \
  sizeof(SHADER_MANAGER_SHADER_CALLBACKS) / \
  sizeof(shadermanagershadercallback_t) \
)

/**
 * Initializes the Shader Manager
 */
void shaderManagerInit();

/**
 * Updates the Shader Manager
 */
void shaderManagerUpdate();

/**
 * Disposes of the Shader Manager
 */
void shaderManagerDispose();